"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.instructionAccountNodeFromIdl = exports.instructionAccountNode = void 0;
const shared_1 = require("../shared");
function instructionAccountNode(input) {
    var _a, _b;
    return {
        kind: 'instructionAccountNode',
        name: (0, shared_1.mainCase)(input.name),
        isWritable: input.isWritable,
        isSigner: input.isSigner,
        isOptional: (_a = input.isOptional) !== null && _a !== void 0 ? _a : false,
        docs: (_b = input.docs) !== null && _b !== void 0 ? _b : [],
        defaultValue: input.defaultValue,
    };
}
exports.instructionAccountNode = instructionAccountNode;
function instructionAccountNodeFromIdl(idl) {
    var _a, _b, _c, _d, _e, _f, _g;
    const isOptional = (_b = (_a = idl.optional) !== null && _a !== void 0 ? _a : idl.isOptional) !== null && _b !== void 0 ? _b : false;
    const desc = idl.desc ? [idl.desc] : undefined;
    return instructionAccountNode({
        name: (_c = idl.name) !== null && _c !== void 0 ? _c : '',
        isWritable: (_d = idl.isMut) !== null && _d !== void 0 ? _d : false,
        isSigner: idl.isOptionalSigner ? 'either' : (_e = idl.isSigner) !== null && _e !== void 0 ? _e : false,
        isOptional,
        docs: (_g = (_f = idl.docs) !== null && _f !== void 0 ? _f : desc) !== null && _g !== void 0 ? _g : [],
    });
}
exports.instructionAccountNodeFromIdl = instructionAccountNodeFromIdl;
//# sourceMappingURL=InstructionAccountNode.js.map