"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.structFieldTypeNodeFromInstructionArgumentNode = exports.structTypeNodeFromInstructionArgumentNodes = exports.instructionArgumentNodeFromIdl = exports.instructionArgumentNode = void 0;
const shared_1 = require("../shared");
const Node_1 = require("./Node");
const typeNodes_1 = require("./typeNodes");
const valueNodes_1 = require("./valueNodes");
function instructionArgumentNode(input) {
    var _a;
    if (!input.name) {
        throw new shared_1.InvalidKinobiTreeError('InstructionArgumentNode must have a name.');
    }
    return {
        kind: 'instructionArgumentNode',
        name: (0, shared_1.mainCase)(input.name),
        type: input.type,
        docs: (_a = input.docs) !== null && _a !== void 0 ? _a : [],
        defaultValue: input.defaultValue,
        defaultValueStrategy: input.defaultValueStrategy,
    };
}
exports.instructionArgumentNode = instructionArgumentNode;
function instructionArgumentNodeFromIdl(idl) {
    var _a, _b;
    return instructionArgumentNode({
        name: (_a = idl.name) !== null && _a !== void 0 ? _a : '',
        type: (0, typeNodes_1.createTypeNodeFromIdl)(idl.type),
        docs: (_b = idl.docs) !== null && _b !== void 0 ? _b : [],
    });
}
exports.instructionArgumentNodeFromIdl = instructionArgumentNodeFromIdl;
function structTypeNodeFromInstructionArgumentNodes(nodes) {
    return (0, typeNodes_1.structTypeNode)(nodes.map(structFieldTypeNodeFromInstructionArgumentNode));
}
exports.structTypeNodeFromInstructionArgumentNodes = structTypeNodeFromInstructionArgumentNodes;
function structFieldTypeNodeFromInstructionArgumentNode(node) {
    if ((0, Node_1.isNode)(node.defaultValue, valueNodes_1.VALUE_NODES)) {
        return (0, typeNodes_1.structFieldTypeNode)({ ...node, defaultValue: node.defaultValue });
    }
    return (0, typeNodes_1.structFieldTypeNode)({
        ...node,
        defaultValue: undefined,
        defaultValueStrategy: undefined,
    });
}
exports.structFieldTypeNodeFromInstructionArgumentNode = structFieldTypeNodeFromInstructionArgumentNode;
//# sourceMappingURL=InstructionArgumentNode.js.map