"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.constantPdaSeedNodeFromBytes = exports.constantPdaSeedNodeFromString = exports.constantPdaSeedNodeFromProgramId = exports.constantPdaSeedNode = void 0;
const contextualValueNodes_1 = require("../contextualValueNodes");
const typeNodes_1 = require("../typeNodes");
const valueNodes_1 = require("../valueNodes");
function constantPdaSeedNode(type, value) {
    return { kind: 'constantPdaSeedNode', type, value };
}
exports.constantPdaSeedNode = constantPdaSeedNode;
function constantPdaSeedNodeFromProgramId() {
    return constantPdaSeedNode((0, typeNodes_1.publicKeyTypeNode)(), (0, contextualValueNodes_1.programIdValueNode)());
}
exports.constantPdaSeedNodeFromProgramId = constantPdaSeedNodeFromProgramId;
function constantPdaSeedNodeFromString(encoding, string) {
    return constantPdaSeedNode((0, typeNodes_1.stringTypeNode)(encoding), (0, valueNodes_1.stringValueNode)(string));
}
exports.constantPdaSeedNodeFromString = constantPdaSeedNodeFromString;
function constantPdaSeedNodeFromBytes(encoding, data) {
    return constantPdaSeedNode((0, typeNodes_1.bytesTypeNode)(), (0, valueNodes_1.bytesValueNode)(encoding, data));
}
exports.constantPdaSeedNodeFromBytes = constantPdaSeedNodeFromBytes;
//# sourceMappingURL=ConstantPdaSeedNode.js.map