"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.enumStructVariantTypeNodeFromIdl = exports.enumStructVariantTypeNode = void 0;
const shared_1 = require("../../shared");
const StructTypeNode_1 = require("./StructTypeNode");
function enumStructVariantTypeNode(name, struct, discriminator) {
    if (!name) {
        throw new shared_1.InvalidKinobiTreeError('EnumStructVariantTypeNode must have a name.');
    }
    return {
        kind: 'enumStructVariantTypeNode',
        name: (0, shared_1.mainCase)(name),
        struct,
        discriminator,
    };
}
exports.enumStructVariantTypeNode = enumStructVariantTypeNode;
function enumStructVariantTypeNodeFromIdl(idl) {
    var _a;
    const name = (_a = idl.name) !== null && _a !== void 0 ? _a : '';
    return enumStructVariantTypeNode(name, (0, StructTypeNode_1.structTypeNodeFromIdl)({
        kind: 'struct',
        fields: idl.fields,
    }));
}
exports.enumStructVariantTypeNodeFromIdl = enumStructVariantTypeNodeFromIdl;
//# sourceMappingURL=EnumStructVariantTypeNode.js.map