"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapTypeNodeFromIdl = exports.mapTypeNode = void 0;
const countNodes_1 = require("../countNodes");
const NumberTypeNode_1 = require("./NumberTypeNode");
const TypeNode_1 = require("./TypeNode");
function mapTypeNode(key, value, count, idlMap) {
    return {
        kind: 'mapTypeNode',
        key,
        value,
        count: (count !== null && count !== void 0 ? count : (0, countNodes_1.prefixedCountNode)((0, NumberTypeNode_1.numberTypeNode)('u32'))),
        idlMap: idlMap !== null && idlMap !== void 0 ? idlMap : 'hashMap',
    };
}
exports.mapTypeNode = mapTypeNode;
function mapTypeNodeFromIdl(idl) {
    const [key, value] = 'hashMap' in idl ? idl.hashMap : idl.bTreeMap;
    let size;
    if (idl.size === 'remainder') {
        size = (0, countNodes_1.remainderCountNode)();
    }
    else if (typeof idl.size === 'number') {
        size = (0, countNodes_1.fixedCountNode)(idl.size);
    }
    else if (idl.size) {
        size = (0, countNodes_1.prefixedCountNode)((0, NumberTypeNode_1.numberTypeNode)(idl.size));
    }
    return mapTypeNode((0, TypeNode_1.createTypeNodeFromIdl)(key), (0, TypeNode_1.createTypeNodeFromIdl)(value), size, 'hashMap' in idl ? 'hashMap' : 'bTreeMap');
}
exports.mapTypeNodeFromIdl = mapTypeNodeFromIdl;
//# sourceMappingURL=MapTypeNode.js.map