"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBytesFromBytesValueNode = exports.bytesValueNode = void 0;
const codecs_strings_1 = require("@solana/codecs-strings");
function bytesValueNode(encoding, data) {
    return { kind: 'bytesValueNode', data, encoding };
}
exports.bytesValueNode = bytesValueNode;
function getBytesFromBytesValueNode(node) {
    switch (node.encoding) {
        case 'utf8':
            return (0, codecs_strings_1.getUtf8Encoder)().encode(node.data);
        case 'base16':
            return (0, codecs_strings_1.getBase16Encoder)().encode(node.data);
        case 'base58':
            return (0, codecs_strings_1.getBase58Encoder)().encode(node.data);
        case 'base64':
        default:
            return (0, codecs_strings_1.getBase64Encoder)().encode(node.data);
    }
}
exports.getBytesFromBytesValueNode = getBytesFromBytesValueNode;
//# sourceMappingURL=BytesValueNode.js.map