"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.constantValueNodeFromBytes = exports.constantValueNodeFromString = exports.constantValueNode = void 0;
const BytesTypeNode_1 = require("../typeNodes/BytesTypeNode");
const StringTypeNode_1 = require("../typeNodes/StringTypeNode");
const BytesValueNode_1 = require("./BytesValueNode");
const StringValueNode_1 = require("./StringValueNode");
function constantValueNode(type, value) {
    return { kind: 'constantValueNode', type, value };
}
exports.constantValueNode = constantValueNode;
function constantValueNodeFromString(encoding, string) {
    return constantValueNode((0, StringTypeNode_1.stringTypeNode)(encoding), (0, StringValueNode_1.stringValueNode)(string));
}
exports.constantValueNodeFromString = constantValueNodeFromString;
function constantValueNodeFromBytes(encoding, data) {
    return constantValueNode((0, BytesTypeNode_1.bytesTypeNode)(), (0, BytesValueNode_1.bytesValueNode)(encoding, data));
}
exports.constantValueNodeFromBytes = constantValueNodeFromBytes;
//# sourceMappingURL=ConstantValueNode.js.map