"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mergeManifests = exports.typeManifest = void 0;
const fragments_1 = require("./fragments");
function typeManifest() {
    return {
        isEnum: false,
        strictType: (0, fragments_1.fragment)(''),
        looseType: (0, fragments_1.fragment)(''),
        encoder: (0, fragments_1.fragment)(''),
        decoder: (0, fragments_1.fragment)(''),
        value: (0, fragments_1.fragment)(''),
    };
}
exports.typeManifest = typeManifest;
function mergeManifests(manifests, options = {}) {
    const { mergeTypes, mergeCodecs, mergeValues } = options;
    const merge = (fragmentFn, mergeFn) => mergeFn ? (0, fragments_1.mergeFragments)(manifests.map(fragmentFn), mergeFn) : (0, fragments_1.fragment)('');
    return {
        isEnum: false,
        strictType: merge((m) => m.strictType, mergeTypes),
        looseType: merge((m) => m.looseType, mergeTypes),
        encoder: merge((m) => m.encoder, mergeCodecs),
        decoder: merge((m) => m.decoder, mergeCodecs),
        value: merge((m) => m.value, mergeValues),
    };
}
exports.mergeManifests = mergeManifests;
//# sourceMappingURL=TypeManifest.js.map