"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAccountTypeFragment = void 0;
const common_1 = require("./common");
const typeWithCodec_1 = require("./typeWithCodec");
function getAccountTypeFragment(scope) {
    const { accountNode, typeManifest, nameApi, customAccountData } = scope;
    const customData = customAccountData.get(accountNode.name);
    const accountDataName = nameApi.accountDataType(accountNode.name);
    const typeWithCodecFragment = customData
        ? (0, common_1.fragment)('')
        : (0, typeWithCodec_1.getTypeWithCodecFragment)({
            name: accountDataName,
            manifest: typeManifest,
            nameApi,
        });
    const dataNameFragment = customData
        ? typeManifest.strictType.clone()
        : (0, common_1.fragment)(nameApi.dataType(accountDataName));
    return (0, common_1.fragmentFromTemplate)('accountType.njk', {
        accountType: nameApi.accountType(accountNode.name),
        accountMaybeType: nameApi.accountMaybeType(accountNode.name),
        dataName: dataNameFragment.render,
        typeWithCodec: typeWithCodecFragment,
    })
        .mergeImportsWith(dataNameFragment, typeWithCodecFragment)
        .addImports('solanaAccounts', ['Account', 'MaybeAccount']);
}
exports.getAccountTypeFragment = getAccountTypeFragment;
//# sourceMappingURL=accountType.js.map