"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getInstructionInputResolvedFragment = void 0;
const nodes_1 = require("../../../nodes");
const shared_1 = require("../../../shared");
const common_1 = require("./common");
const instructionInputDefault_1 = require("./instructionInputDefault");
function getInstructionInputResolvedFragment(scope) {
    const resolvedInputFragments = scope.resolvedInputs.flatMap((input) => {
        const inputFragment = (0, instructionInputDefault_1.getInstructionInputDefaultFragment)({
            ...scope,
            input,
            optionalAccountStrategy: scope.instructionNode.optionalAccountStrategy,
        });
        if (!inputFragment.render)
            return [];
        const camelName = (0, shared_1.camelCase)(input.name);
        return [
            inputFragment.mapRender((r) => (0, nodes_1.isNode)(input, 'instructionArgumentNode')
                ? `if (!args.${camelName}) {\n${r}\n}`
                : `if (!accounts.${camelName}.value) {\n${r}\n}`),
        ];
    });
    if (resolvedInputFragments.length === 0) {
        return (0, common_1.fragment)('');
    }
    return (0, common_1.mergeFragments)([(0, common_1.fragment)('// Resolve default values.'), ...resolvedInputFragments], (renders) => renders.join('\n'));
}
exports.getInstructionInputResolvedFragment = getInstructionInputResolvedFragment;
//# sourceMappingURL=instructionInputResolved.js.map