"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.renderJavaScriptVisitor = void 0;
const shared_1 = require("../../shared");
const visitors_1 = require("../../visitors");
const getRenderMapVisitor_1 = require("./getRenderMapVisitor");
const getValidatorBagVisitor_1 = require("./getValidatorBagVisitor");
function renderJavaScriptVisitor(path, options = {}) {
    return (0, visitors_1.rootNodeVisitor)((root) => {
        var _a;
        // Validate nodes.
        (0, visitors_1.visit)(root, (0, visitors_1.throwValidatorItemsVisitor)((0, getValidatorBagVisitor_1.getValidatorBagVisitor)(), options.throwLevel));
        // Delete existing generated folder.
        if ((_a = options.deleteFolderBeforeRendering) !== null && _a !== void 0 ? _a : true) {
            (0, shared_1.deleteFolder)(path);
        }
        // Render the new files.
        (0, visitors_1.visit)(root, (0, visitors_1.writeRenderMapVisitor)((0, getRenderMapVisitor_1.getRenderMapVisitor)(options), path));
    });
}
exports.renderJavaScriptVisitor = renderJavaScriptVisitor;
//# sourceMappingURL=renderJavaScriptVisitor.js.map