import type { IdlAccount } from '../idl';
import { MainCaseString } from '../shared';
import { DiscriminatorNode } from './discriminatorNodes';
import { PdaLinkNode } from './linkNodes';
import { NestedTypeNode, StructTypeNode } from './typeNodes';
export interface AccountNode<TData extends NestedTypeNode<StructTypeNode> = NestedTypeNode<StructTypeNode>, TPda extends PdaLinkNode | undefined = PdaLinkNode | undefined, TDiscriminators extends DiscriminatorNode[] | undefined = DiscriminatorNode[] | undefined> {
    readonly kind: 'accountNode';
    readonly data: TData;
    readonly pda?: TPda;
    readonly discriminators?: TDiscriminators;
    readonly name: MainCaseString;
    readonly idlName: string;
    readonly docs: string[];
    readonly size?: number | null;
}
export type AccountNodeInput<TData extends NestedTypeNode<StructTypeNode> = NestedTypeNode<StructTypeNode>, TPda extends PdaLinkNode | undefined = PdaLinkNode | undefined, TDiscriminators extends DiscriminatorNode[] | undefined = DiscriminatorNode[] | undefined> = Omit<Partial<AccountNode<TData, TPda, TDiscriminators>>, 'kind' | 'name'> & {
    readonly name: string;
};
export declare function accountNode<TData extends NestedTypeNode<StructTypeNode> = StructTypeNode<[]>, TPda extends PdaLinkNode | undefined = undefined, const TDiscriminators extends DiscriminatorNode[] | undefined = undefined>(input: AccountNodeInput<TData, TPda, TDiscriminators>): AccountNode<TData, TPda, TDiscriminators>;
export declare function accountNodeFromIdl(idl: Partial<IdlAccount>): AccountNode<StructTypeNode>;
