import type { IdlDefinedType } from '../idl';
import { MainCaseString } from '../shared';
import { TypeNode } from './typeNodes/TypeNode';
export interface DefinedTypeNode<TType extends TypeNode = TypeNode> {
    readonly kind: 'definedTypeNode';
    readonly type: TType;
    readonly name: MainCaseString;
    readonly idlName: string;
    readonly docs: string[];
}
export type DefinedTypeNodeInput<TType extends TypeNode = TypeNode> = {
    readonly name: string;
    readonly type: TType;
    readonly idlName?: string;
    readonly docs?: string[];
};
export declare function definedTypeNode<TType extends TypeNode>(input: DefinedTypeNodeInput<TType>): DefinedTypeNode<TType>;
export declare function definedTypeNodeFromIdl(idl: Partial<IdlDefinedType>): DefinedTypeNode;
