import { ValueNode } from '../valueNodes';
import { AccountValueNode } from './AccountValueNode';
import { ArgumentValueNode } from './ArgumentValueNode';
import { InstructionInputValueNode } from './ContextualValueNode';
import { ResolverValueNode } from './ResolverValueNode';
export type ConditionalValueBranch = InstructionInputValueNode;
export declare const CONDITIONAL_VALUE_BRANCH_NODES: ("arrayValueNode" | "bytesValueNode" | "booleanValueNode" | "constantValueNode" | "enumValueNode" | "mapValueNode" | "noneValueNode" | "numberValueNode" | "setValueNode" | "someValueNode" | "structValueNode" | "tupleValueNode" | "publicKeyValueNode" | "stringValueNode" | "accountBumpValueNode" | "accountValueNode" | "argumentValueNode" | "conditionalValueNode" | "identityValueNode" | "payerValueNode" | "pdaValueNode" | "programIdValueNode" | "resolverValueNode" | "programLinkNode")[];
export interface ConditionalValueNode<TCondition extends ResolverValueNode | AccountValueNode | ArgumentValueNode = ResolverValueNode | AccountValueNode | ArgumentValueNode, TValue extends ValueNode | undefined = ValueNode | undefined, TIfTrue extends ConditionalValueBranch | undefined = ConditionalValueBranch | undefined, TIfFalse extends ConditionalValueBranch | undefined = ConditionalValueBranch | undefined> {
    readonly kind: 'conditionalValueNode';
    readonly condition: TCondition;
    readonly value?: TValue;
    readonly ifTrue?: TIfTrue;
    readonly ifFalse?: TIfFalse;
}
export declare function conditionalValueNode<TCondition extends ResolverValueNode | AccountValueNode | ArgumentValueNode, TValue extends ValueNode | undefined = undefined, TIfTrue extends ConditionalValueBranch | undefined = undefined, TIfFalse extends ConditionalValueBranch | undefined = undefined>(input: {
    condition: TCondition;
    value?: TValue;
    ifTrue?: TIfTrue;
    ifFalse?: TIfFalse;
}): ConditionalValueNode<TCondition, TValue, TIfTrue, TIfFalse>;
