import { ImportFrom, MainCaseString } from '../../shared';
import { AccountValueNode } from './AccountValueNode';
import { ArgumentValueNode } from './ArgumentValueNode';
export interface ResolverValueNode<TDependsOn extends (AccountValueNode | ArgumentValueNode)[] = (AccountValueNode | ArgumentValueNode)[]> {
    readonly kind: 'resolverValueNode';
    readonly dependsOn?: TDependsOn;
    readonly name: MainCaseString;
    readonly importFrom?: ImportFrom;
}
export declare function resolverValueNode<const TDependsOn extends (AccountValueNode | ArgumentValueNode)[] = []>(name: string, options?: {
    importFrom?: ResolverValueNode['importFrom'];
    dependsOn?: TDependsOn;
}): ResolverValueNode<TDependsOn>;
