import type { IdlTypeArray, IdlTypeVec } from '../../idl';
import { CountNode, PrefixedCountNode } from '../countNodes';
import { NumberTypeNode } from './NumberTypeNode';
import { TypeNode } from './TypeNode';
export interface ArrayTypeNode<TItem extends TypeNode = TypeNode, TCount extends CountNode = CountNode> {
    readonly kind: 'arrayTypeNode';
    readonly item: TItem;
    readonly count: TCount;
}
export declare function arrayTypeNode<TItem extends TypeNode, TCount extends CountNode = PrefixedCountNode<NumberTypeNode<'u32'>>>(item: TItem, count?: TCount): ArrayTypeNode<TItem, TCount>;
export declare function arrayTypeNodeFromIdl(idl: IdlTypeArray | IdlTypeVec): ArrayTypeNode;
