import type { NestedTypeNode } from './NestedTypeNode';
import type { IdlTypeEnumVariant } from '../../idl';
import { MainCaseString } from '../../shared';
import { TupleTypeNode } from './TupleTypeNode';
export interface EnumTupleVariantTypeNode<TTuple extends NestedTypeNode<TupleTypeNode> = NestedTypeNode<TupleTypeNode>> {
    readonly kind: 'enumTupleVariantTypeNode';
    readonly tuple: TTuple;
    readonly name: MainCaseString;
    readonly discriminator?: number;
}
export declare function enumTupleVariantTypeNode<TTuple extends NestedTypeNode<TupleTypeNode>>(name: string, tuple: TTuple, discriminator?: number): EnumTupleVariantTypeNode<TTuple>;
export declare function enumTupleVariantTypeNodeFromIdl(idl: IdlTypeEnumVariant): EnumTupleVariantTypeNode<TupleTypeNode>;
