import type { NestedTypeNode } from './NestedTypeNode';
import type { IdlTypeEnum } from '../../idl';
import type { EnumVariantTypeNode } from './EnumVariantTypeNode';
import { NumberTypeNode } from './NumberTypeNode';
export interface EnumTypeNode<TVariants extends EnumVariantTypeNode[] = EnumVariantTypeNode[], TSize extends NestedTypeNode<NumberTypeNode> = NestedTypeNode<NumberTypeNode>> {
    readonly kind: 'enumTypeNode';
    readonly variants: TVariants;
    readonly size: TSize;
}
export declare function enumTypeNode<const TVariants extends EnumVariantTypeNode[], TSize extends NestedTypeNode<NumberTypeNode> = NumberTypeNode<'u8'>>(variants: TVariants, options?: {
    size?: TSize;
}): EnumTypeNode<TVariants, TSize>;
export declare function enumTypeNodeFromIdl(idl: IdlTypeEnum): EnumTypeNode<EnumVariantTypeNode[], NumberTypeNode>;
export declare function isScalarEnum(node: EnumTypeNode): boolean;
export declare function isDataEnum(node: EnumTypeNode): boolean;
