import { Node } from '../Node';
import type { FixedSizeTypeNode } from './FixedSizeTypeNode';
import type { HiddenPrefixTypeNode } from './HiddenPrefixTypeNode';
import type { HiddenSuffixTypeNode } from './HiddenSuffixTypeNode';
import type { PostOffsetTypeNode } from './PostOffsetTypeNode';
import type { PreOffsetTypeNode } from './PreOffsetTypeNode';
import type { SentinelTypeNode } from './SentinelTypeNode';
import type { SizePrefixTypeNode } from './SizePrefixTypeNode';
import { TypeNode } from './TypeNode';
export type NestedTypeNode<TType extends TypeNode> = TType | FixedSizeTypeNode<NestedTypeNode<TType>> | HiddenPrefixTypeNode<NestedTypeNode<TType>> | HiddenSuffixTypeNode<NestedTypeNode<TType>> | PostOffsetTypeNode<NestedTypeNode<TType>> | PreOffsetTypeNode<NestedTypeNode<TType>> | SentinelTypeNode<NestedTypeNode<TType>> | SizePrefixTypeNode<NestedTypeNode<TType>>;
export declare function resolveNestedTypeNode<TType extends TypeNode>(typeNode: NestedTypeNode<TType>): TType;
export declare function transformNestedTypeNode<TFrom extends TypeNode, TTo extends TypeNode>(typeNode: NestedTypeNode<TFrom>, map: (type: TFrom) => TTo): NestedTypeNode<TTo>;
export declare function isNestedTypeNode<TKind extends TypeNode['kind']>(node: Node | null | undefined, kind: TKind | TKind[]): node is NestedTypeNode<Extract<TypeNode, {
    kind: TKind;
}>>;
export declare function assertIsNestedTypeNode<TKind extends TypeNode['kind']>(node: Node | null | undefined, kind: TKind | TKind[]): asserts node is NestedTypeNode<Extract<TypeNode, {
    kind: TKind;
}>>;
