import type { IdlTypeSet } from '../../idl';
import { CountNode, PrefixedCountNode } from '../countNodes';
import { NumberTypeNode } from './NumberTypeNode';
import { TypeNode } from './TypeNode';
export interface SetTypeNode<TItem extends TypeNode = TypeNode, TCount extends CountNode = CountNode> {
    readonly kind: 'setTypeNode';
    readonly item: TItem;
    readonly count: TCount;
    readonly idlSet: 'hashSet' | 'bTreeSet';
}
export declare function setTypeNode<TItem extends TypeNode = TypeNode, TCount extends CountNode = PrefixedCountNode<NumberTypeNode<'u32'>>>(item: TItem, count?: TCount, idlSet?: SetTypeNode['idlSet']): SetTypeNode<TItem, TCount>;
export declare function setTypeNodeFromIdl(idl: IdlTypeSet): SetTypeNode;
