import type { IdlTypeStructField } from '../../idl';
import { MainCaseString } from '../../shared';
import { ValueNode } from '../valueNodes';
import { TypeNode } from './TypeNode';
export interface StructFieldTypeNode<TType extends TypeNode = TypeNode, TDefaultValue extends ValueNode | undefined = ValueNode | undefined> {
    readonly kind: 'structFieldTypeNode';
    readonly type: TType;
    readonly defaultValue?: TDefaultValue;
    readonly name: MainCaseString;
    readonly docs: string[];
    readonly defaultValueStrategy?: 'optional' | 'omitted';
}
export type StructFieldTypeNodeInput<TType extends TypeNode = TypeNode, TDefaultValue extends ValueNode | undefined = ValueNode | undefined> = {
    readonly name: string;
    readonly type: TType;
    readonly docs?: string[];
    readonly defaultValue?: TDefaultValue;
    readonly defaultValueStrategy?: 'optional' | 'omitted';
};
export declare function structFieldTypeNode<TType extends TypeNode, TDefaultValue extends ValueNode | undefined = undefined>(input: StructFieldTypeNodeInput<TType, TDefaultValue>): StructFieldTypeNode<TType, TDefaultValue>;
export declare function structFieldTypeNodeFromIdl(idl: IdlTypeStructField): StructFieldTypeNode;
