import { StringEncoding } from '../typeNodes/StringTypeNode';
import { TypeNode } from '../typeNodes/TypeNode';
import { BytesEncoding } from './BytesValueNode';
import { ValueNode } from './ValueNode';
export interface ConstantValueNode<TType extends TypeNode = TypeNode, TValue extends ValueNode = ValueNode> {
    readonly kind: 'constantValueNode';
    readonly type: TType;
    readonly value: TValue;
}
export declare function constantValueNode<TType extends TypeNode, TValue extends ValueNode>(type: TType, value: TValue): ConstantValueNode<TType, TValue>;
export declare function constantValueNodeFromString<TEncoding extends StringEncoding>(encoding: TEncoding, string: string): ConstantValueNode<import("../typeNodes/StringTypeNode").StringTypeNode<TEncoding>, import("./StringValueNode").StringValueNode>;
export declare function constantValueNodeFromBytes<TEncoding extends BytesEncoding>(encoding: TEncoding, data: string): ConstantValueNode<import("../typeNodes/BytesTypeNode").BytesTypeNode, import("./BytesValueNode").BytesValueNode>;
