import { LinkableDictionary, MainCaseString } from '../../shared';
import { Visitor } from '../../visitors';
import { TypeManifest } from './TypeManifest';
import { ParsedCustomDataOptions } from './customDataHelpers';
import { NameApi } from './nameTransformers';
export type TypeManifestVisitor = ReturnType<typeof getTypeManifestVisitor>;
export declare function getTypeManifestVisitor(input: {
    nameApi: NameApi;
    linkables: LinkableDictionary;
    nonScalarEnums: MainCaseString[];
    customAccountData: ParsedCustomDataOptions;
    customInstructionData: ParsedCustomDataOptions;
    parentName?: {
        strict: string;
        loose: string;
    };
}): Visitor<TypeManifest, "arrayValueNode" | "bytesValueNode" | "booleanValueNode" | "constantValueNode" | "enumValueNode" | "mapValueNode" | "noneValueNode" | "numberValueNode" | "setValueNode" | "someValueNode" | "structValueNode" | "tupleValueNode" | "publicKeyValueNode" | "stringValueNode" | "definedTypeLinkNode" | "amountTypeNode" | "arrayTypeNode" | "booleanTypeNode" | "bytesTypeNode" | "dateTimeTypeNode" | "enumTypeNode" | "fixedSizeTypeNode" | "hiddenPrefixTypeNode" | "hiddenSuffixTypeNode" | "mapTypeNode" | "numberTypeNode" | "optionTypeNode" | "postOffsetTypeNode" | "preOffsetTypeNode" | "publicKeyTypeNode" | "sentinelTypeNode" | "setTypeNode" | "sizePrefixTypeNode" | "solAmountTypeNode" | "stringTypeNode" | "structTypeNode" | "tupleTypeNode" | "zeroableOptionTypeNode" | "structFieldTypeNode" | "enumEmptyVariantTypeNode" | "enumStructVariantTypeNode" | "enumTupleVariantTypeNode" | "mapEntryValueNode" | "structFieldValueNode" | "accountNode" | "instructionNode" | "definedTypeNode">;
