import { AccountNode, DefinedTypeLinkNode, DefinedTypeNode, InstructionNode } from '../../nodes';
import { ImportFrom, MainCaseString } from '../../shared';
export type CustomDataOptions = string | {
    name: string;
    importAs?: string;
    importFrom?: ImportFrom;
    extractAs?: string;
    extract?: boolean;
};
export type ParsedCustomDataOptions = Map<MainCaseString, {
    importAs: MainCaseString;
    importFrom: ImportFrom;
    extractAs: MainCaseString;
    extract: boolean;
    linkNode: DefinedTypeLinkNode;
}>;
export declare const parseCustomDataOptions: (customDataOptions: CustomDataOptions[], defaultSuffix: string) => ParsedCustomDataOptions;
export declare const getDefinedTypeNodesToExtract: (nodes: AccountNode[] | InstructionNode[], parsedCustomDataOptions: ParsedCustomDataOptions) => DefinedTypeNode[];
