import { AccountLinkNode, AccountNode, DefinedTypeLinkNode, DefinedTypeNode, LinkNode, PdaLinkNode, PdaNode, ProgramLinkNode, ProgramNode } from '../nodes';
export type LinkableNode = ProgramNode | PdaNode | AccountNode | DefinedTypeNode;
export declare class LinkableDictionary {
    private readonly programs;
    private readonly pdas;
    private readonly accounts;
    private readonly definedTypes;
    record(node: LinkableNode): this;
    recordAll(nodes: LinkableNode[]): this;
    get(linkNode: ProgramLinkNode): ProgramNode | undefined;
    get(linkNode: PdaLinkNode): PdaNode | undefined;
    get(linkNode: AccountLinkNode): AccountNode | undefined;
    get(linkNode: DefinedTypeLinkNode): DefinedTypeNode | undefined;
    has(linkNode: LinkNode): boolean;
}
