import { AccountValueNode, ArgumentValueNode, InstructionAccountNode, InstructionArgumentNode } from '../nodes';
import { Visitor } from './visitor';
export type ResolvedInstructionInput = ResolvedInstructionAccount | ResolvedInstructionArgument;
export type ResolvedInstructionAccount = InstructionAccountNode & {
    isPda: boolean;
    dependsOn: InstructionDependency[];
    resolvedIsSigner: boolean | 'either';
    resolvedIsOptional: boolean;
};
export type ResolvedInstructionArgument = InstructionArgumentNode & {
    dependsOn: InstructionDependency[];
};
type InstructionDependency = ArgumentValueNode | AccountValueNode;
export declare function getResolvedInstructionInputsVisitor(options?: {
    includeDataArgumentValueNodes?: boolean;
}): Visitor<ResolvedInstructionInput[], 'instructionNode'>;
export {};
