import { GetNodeFromKind, Node, NodeKind } from '../nodes';
export type Visitor<TReturn, TNodeKind extends NodeKind = NodeKind> = {
    [K in TNodeKind as GetVisitorFunctionName<K>]: (node: GetNodeFromKind<K>) => TReturn;
};
export type GetVisitorFunctionName<T extends Node['kind']> = T extends `${infer TWithoutNode}Node` ? `visit${Capitalize<TWithoutNode>}` : never;
export declare function visit<TReturn>(node: Node, visitor: Visitor<TReturn>): TReturn;
export declare function visit<TReturn, TNode extends Node>(node: TNode, visitor: Visitor<TReturn, TNode['kind']>): TReturn;
export declare function visitOrElse<TReturn>(node: Node, visitor: Visitor<TReturn, any>, fallback: (node: Node) => TReturn): TReturn;
export declare function getVisitFunctionName<T extends Node['kind']>(node: T): GetVisitorFunctionName<T>;
